// Prescribble reader


#include "prescribble.hpp"
#include <vector>
#include <string>



#ifndef USE_EXPAT
#define USE_EXPAT 0
#else
#include <xmlparse.h>
#endif

/**
 * reads in notes from file
 */

namespace Prescribble {
    class Reader {
    protected:
        NoteConfig &m_config;
        NoteListener *m_pListener;
        
    public:
        typedef std::vector<Note*> NotesVector;
        
        Reader( NoteConfig &a_config,
                NoteListener *a_pListener);
        
        bool loadInto( const char *filename, NotesVector &a_notes );
        
    };
    typedef Reader PrescribbleReader;
    
    
    class XMLReader : public Reader {
    protected:
        bool m_appending;
        NotesVector *m_pNotes;
        std::string m_strData;
    public:
        XMLReader(NoteConfig &a_config, NoteListener *a_pListener);
        
        bool loadInto( const char *filename, NotesVector &a_notes );
        
        void processStringData();
        
    protected:
        static void start_cb(void *userData, 
                             const char *name, const char **atts);
        static void data_cb(void *userData, const char *data, int len);
        static void end_cb(void *userData, const char *name);
        
    };
    typedef XMLReader PrescribbleXMLReader;
    
}; // namespace Prescribble
