#!/usr/local/bin/ruby 

#######################################
# prescrib2png
#
# A class for converting a Prescribble.dat into a PNG.
# Still a hack.
#
# Author: Kent Dahl ( MenThal@bigfoot.com )
#
# Requirements: 
# - Ruby ( http://www.lang-ruby.org )
# - NQXML ( http://www.io.com/~jimm/downloads/nqxml/index.html )
# - GD graphics library with PNG support
# - Ruby/GD library binding
#
#

require 'GD'
require 'prescrib2svg'

module Prescribble
  def Prescribble::makeGDImage( notebook, a4pagewidth = 4 )
    agendaheight = 240
    agendawidth = 160

    a4pageheight, remainder = notebook.size.divmod a4pagewidth
    a4pageheight += ( remainder>0 ? 1 : 0 )
    
  notepage = 0
  basex = 0
  basey = 0


  width = agendawidth * a4pagewidth
  height = agendaheight * a4pageheight

  im = GD::Image.new( width, height )
  white = im.colorAllocate(255,255,255)
  black = im.colorAllocate(0,0,0)       
  
  im.transparent(white)
  im.interlace = true


  notebook.each{|note|
    basey = agendaheight* ((notepage/a4pagewidth).to_i)
    basex = agendawidth*  ((notepage%a4pagewidth).to_i)
    im.rectangle( basex, basey, 
		 basex + agendawidth, 
		 basey + agendaheight, black )


    note.each{|stroke|
      point = nil 
      stroke.each{|nextpoint|
	if !point.nil?
	  x,y = nextpoint
	  x1,y1 = point
	  im.line( x+basex,  y+basey,
		  x1+basex, y1+basey , black )
	end

	point = nextpoint
      }
    }



    notepage += 1
  }

  im

  end
end # Prescribble





# Main part
if $0 == __FILE__
  begin
    f = ARGV[0]
    if f.nil? then raise "No inputfile specified." end

    books = Prescribble::loadPrescribbleStrokes( f )
    if books.nil? && books.size != 1 then raise "Unexpected notebook size!" end
    im = Prescribble::makePNG( books[0] ) 
    File.open( f + ".png", "w" ){|file|
      im.png file
      file.flush
    }

  rescue Exception => err
    puts "Error: " + err.to_s
  end
end
